{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                       йԼѵ                           }
{                   (C)Copyright 2001, 2003 CnPack                       }
{                   ------------------------------------                       }
{                                                                              }
{            һGNU         }
{        ͨù֤޸ĺ·һ򣬻֤        }
{        ڶ棬ߣѡκθµİ汾                        }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ GNU Ͽͨù         }
{        ֤                                                            }
{                                                                              }
{            ӦѾͿһյһ GNU Ͽͨù֤         }
{        ûУдŸ                                            }
{            Free Software Foundation, Inc., 59 Temple Place - Suite           }
{        330, Boston, MA 02111-1307, USA.                                      }
{                                                                              }
{          ԭʼļCnWizMenuHook.pas                                       }
{            Ԫߣܾ¹裩                                      }
{                      yygw@yygw.net; http://www.yygw.net                      }
{            صַhttp://www.cnvcl.org                                    }
{            ʼcnpack@163.com                                          }
{                עIDE ڲ˵ҽӷԪ                            }
{                                                                              }
{******************************************************************************}

unit CnWizMenuHook;
{ |<PRE>
================================================================================
* ƣCnWizards IDE רҹ߰
* ԪƣIDE ڲ˵ҽӷԪ
* Ԫߣܾ¹裩 yygw@yygw.net; http://www.yygw.net
*     עõԪʵֶ IDE ڲ PopupMenu ĹҽӲͨ޸Ĳ˵
*           OnPopup ¼ڵǰɾԶĲ˵ִԭ OnPopup 
*           ӶĲ˵ʵԶ˵Ĺܡ
*           ֮Բø÷Ϊֱ޸ PopupMenu  IDE пܻᵼ³
*           Ԫṩࣺ
*             - TCnAbstractUserMenuItem
*               û˵࣬ҪرƵĲ˵񣬿Լ
*               Ӹ
*             - TCnUserMenuItem
*               ͨû˵࣬󲿷ҪʹʱֱӴʵ
*               עᵽмɡ
*             - TCnSepMenuItem
*               һָ˵
*             - TCnMenuHook
*               ˵ڹһͬܵĲ˵༭ܻж
*               ʵÿʵһ PopupMenuͿһ
*               ṩ˹ҽ PopupMenu עԶ˵Լ
*               
* ƽ̨PWin2000Pro + Delphi 5.01
* ݲԣPWin9X/2000/XP + Delphi 5/6/7 + C++Builder 5/6
*   õԪеֱַ֧ػʽ
* ¼¼2003.05.01 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

{ $I CnPack.inc}

uses
  Windows, Messages, SysUtils, Classes,
{$IFNDEF VER120}
  Contnrs,
{$ENDIF}
  ActnList, Menus;

type

//==============================================================================
// û˵
//==============================================================================

{ TCnAbstractUserMenuItem }

  TCnMenuItemInsertPos = (ipFirst, ipLast, ipAfter, ipBefore);
  TCnMenuItemStatus = set of (msVisible, msEnabled, msChecked);

  TCnAbstractUserMenuItem = class(TObject)
  private
    FActive: Boolean;
  protected
    function GetName: string; virtual; abstract;
    function GetInsertPos: TCnMenuItemInsertPos; virtual; abstract;
    function GetRelItemName: string; virtual; abstract;
    function GetCaption: string; virtual; abstract;
    function GetHint: string; virtual; abstract;
    function GetStatus : TCnMenuItemStatus; virtual; abstract;
    function GetAction: TCustomAction; virtual; abstract;

    procedure MenuItemCreated(MenuItem: TMenuItem); virtual; abstract;
    {* û˵ø÷}
  public
    procedure Execute(Sender: TObject); virtual; abstract;
    {* ˵ִз}

    property Active: Boolean read FActive write FActive;
    property Name: string read GetName;
    property InsertPos: TCnMenuItemInsertPos read GetInsertPos;
    {* û˵Ĳλ}
    property RelItemName: string read GetRelItemName;
    {*  InsertPos Ϊ ipAfter, ipBefore ʱԵԭ˵}
    property Caption: string read GetCaption;
    property Hint: string read GetHint;
    property Status: TCnMenuItemStatus read GetStatus;
    property Action: TCustomAction read GetAction;
  end;

//==============================================================================
// ͨû˵
//==============================================================================

{ TCnUserMenuItem }

  TMenuItemCreatedEvent = procedure (Sender: TObject; MenuItem: TMenuItem) of object;

  TCnUserMenuItem = class(TCnAbstractUserMenuItem)
  private
    FName: string;
    FInsertPos: TCnMenuItemInsertPos;
    FRelItemName: string;
    FCaption: string;
    FHint: string;
    FAction: TCustomAction;
    FOnClick: TNotifyEvent;
    FOnCreated: TMenuItemCreatedEvent;
  protected
    function GetName: string; override;
    function GetInsertPos: TCnMenuItemInsertPos; override;
    function GetRelItemName: string; override;
    function GetCaption: string; override;
    function GetHint: string; override;
    function GetStatus : TCnMenuItemStatus; override;
    function GetAction: TCustomAction; override;
    procedure MenuItemCreated(MenuItem: TMenuItem); override;
  public
    constructor Create(const AName, ACaption: string; AOnClick: TNotifyEvent;
      AInsertPos: TCnMenuItemInsertPos; const ARelItemName: string = '';
      const AHint: string = ''; AAction: TCustomAction = nil);
    destructor Destroy; override;
    procedure Execute(Sender: TObject); override;

    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnCreated: TMenuItemCreatedEvent read FOnCreated write FOnCreated;
  end;

//==============================================================================
// ָ˵
//==============================================================================

{ TCnSepMenuItem }

  TCnSepMenuItem = class(TCnUserMenuItem)
  public
    constructor Create(AInsertPos: TCnMenuItemInsertPos; const ARelItemName: string);
  end;

//==============================================================================
// ҽӵĲ˵
//==============================================================================

{ TMenuObj }

  TMenuObj = class(TObject)
  private
    FOldOnPopup: TNotifyEvent;
    FMenu: TPopupMenu;
  public
    constructor Create(AMenu: TPopupMenu; NewOnPopup: TNotifyEvent);
    destructor Destroy; override;
    property Menu: TPopupMenu read FMenu;
    property OldOnPopup: TNotifyEvent read FOldOnPopup;
  end;

//==============================================================================
// ˵ҽӹ
//==============================================================================

{ TCnMenuHook }

  THookMenuItemEvent = procedure (Sender: TObject; Menu: TPopupMenu) of object;

  TCnMenuHook = class(TComponent)
  private
{$IFDEF VER120}  //for D4 only
    FMenuList: TList;
{$ELSE}
    FMenuList: TObjectList;
{$ENDIF}
    FHookItemList: TList;
    FActive: Boolean;
    FOnAddMenuItem: THookMenuItemEvent;
    FOnRemoveMenuItem: THookMenuItemEvent;
    procedure SetActive(const Value: Boolean);
    function GetUserMenuItem(Index: Integer): TCnAbstractUserMenuItem;
    function GetUserMenuItemCount: Integer;
  protected
    function GetMenuObj(Menu: TPopupMenu): TMenuObj;
    procedure OnMenuPopup(Sender: TObject); virtual;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    function FindMenuItem(AMenu: TPopupMenu; const AName: string): TMenuItem;
    procedure DoRemoveMenuItem(AMenu: TPopupMenu; const AName: string);
    procedure DoAddMenuItem(AMenu: TPopupMenu; Item: TCnAbstractUserMenuItem);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure HookMenu(AMenu: TPopupMenu);
    procedure UnHookMenu(AMenu: TPopupMenu);
    function IsHooked(AMenu: TPopupMenu): Boolean;

    function AddUserMenuItem(Item: TCnAbstractUserMenuItem): Integer;
    procedure RemoveUserMenuItem(Item: TCnAbstractUserMenuItem);
    function IndexOfUserMenuItem(const AName: string): Integer;

    property Active: Boolean read FActive write SetActive;
    property UserMenuItemCount: Integer read GetUserMenuItemCount;
    property UserMenuItems[Index: Integer]: TCnAbstractUserMenuItem read GetUserMenuItem;
    property OnRemoveMenuItem: THookMenuItemEvent read FOnRemoveMenuItem write FOnRemoveMenuItem;
    property OnAddMenuItem: THookMenuItemEvent read FOnAddMenuItem write FOnAddMenuItem;
  end;

implementation

const
  csUserMenuItemTag = $8080;

{$IFDEF VER120}  //for D4 only
function SameText(s1, s2 : String) : boolean;
begin
  Result := CompareText(S1, S2) = 0;
end;
{$ENDIF}

//==============================================================================
// ͨû˵
//==============================================================================

{ TCnUserMenuItem }

constructor TCnUserMenuItem.Create(const AName, ACaption: string;
  AOnClick: TNotifyEvent; AInsertPos: TCnMenuItemInsertPos; const ARelItemName,
  AHint: string; AAction: TCustomAction);
begin
  inherited Create;
  FActive := True;
  FName := AName;
  FCaption := ACaption;
  FOnClick := AOnClick;
  FInsertPos := AInsertPos;
  FRelItemName := ARelItemName;
  FHint := AHint;
  FAction := AAction;
  FOnCreated := nil;
end;

destructor TCnUserMenuItem.Destroy;
begin

  inherited;
end;

procedure TCnUserMenuItem.Execute(Sender: TObject);
begin
  if Assigned(FOnClick) then
    FOnClick(Sender);
end;

function TCnUserMenuItem.GetAction: TCustomAction;
begin
  Result := FAction;
end;

function TCnUserMenuItem.GetCaption: string;
begin
  Result := FCaption;
end;

function TCnUserMenuItem.GetHint: string;
begin
  Result := FHint;
end;

function TCnUserMenuItem.GetInsertPos: TCnMenuItemInsertPos;
begin
  Result := FInsertPos;
end;

function TCnUserMenuItem.GetName: string;
begin
  Result := FName;
end;

function TCnUserMenuItem.GetRelItemName: string;
begin
  Result := FRelItemName;
end;

function TCnUserMenuItem.GetStatus: TCnMenuItemStatus;
begin
  Result := [msVisible, msEnabled];
end;

procedure TCnUserMenuItem.MenuItemCreated(MenuItem: TMenuItem);
begin
  if Assigned(FOnCreated) then
    FOnCreated(Self, MenuItem);
end;

//==============================================================================
// ָ˵
//==============================================================================

{ TCnSepMenuItem }

constructor TCnSepMenuItem.Create(AInsertPos: TCnMenuItemInsertPos;
  const ARelItemName: string);
begin
  inherited Create('', '-', nil, AInsertPos, ARelItemName, '', nil);
end;

//==============================================================================
// ҽӵĲ˵
//==============================================================================

{ TMenuObj }

constructor TMenuObj.Create(AMenu: TPopupMenu; NewOnPopup: TNotifyEvent);
begin
  inherited Create;
  FMenu := AMenu;
  FOldOnPopup := FMenu.OnPopup;
  FMenu.OnPopup := NewOnPopup;
end;

destructor TMenuObj.Destroy;
begin
  FMenu.OnPopup := FOldOnPopup;
  inherited;
end;

//==============================================================================
// ˵ҽӹ
//==============================================================================

{ TCnMenuHook }

constructor TCnMenuHook.Create(AOwner: TComponent);
begin
  inherited;
{$IFDEF VER120}  //for D4 only
  FMenuList := TList.Create;
{$ELSE}
  FMenuList := TObjectList.Create;
{$ENDIF}
  FHookItemList := TList.Create;
  FActive := True;
  FOnAddMenuItem := nil;
  FOnRemoveMenuItem := nil;
end;

destructor TCnMenuHook.Destroy;
begin
  FHookItemList.Free;
  FMenuList.Free;
  inherited;
end;

//------------------------------------------------------------------------------
// ˵
//------------------------------------------------------------------------------

function TCnMenuHook.FindMenuItem(AMenu: TPopupMenu;
  const AName: string): TMenuItem;
var
  i: Integer;
begin
  Result := nil;
  if (AMenu = nil) or (AName = '') then Exit;

  for i := 0 to AMenu.Items.Count - 1 do
    if SameText(AMenu.Items[i].Name, AName) then
    begin
      Result := AMenu.Items[i];
      Exit;
    end;
end;

procedure TCnMenuHook.DoAddMenuItem(AMenu: TPopupMenu;
  Item: TCnAbstractUserMenuItem);
var
  MenuItem, RelItem: TMenuItem;
  Idx: Integer;
begin
  Assert(Assigned(AMenu));
  Assert(Assigned(Item));
  
  if FActive and Item.Active then
  begin
    MenuItem := FindMenuItem(AMenu, Item.Name);
    if not Assigned(MenuItem) then
    begin
      MenuItem := TMenuItem.Create(AMenu);
      MenuItem.Name := Item.Name;

      RelItem := FindMenuItem(AMenu, Item.RelItemName);
      Idx := 0;
      case Item.InsertPos of
        ipFirst: Idx := 0;
        ipLast: Idx := AMenu.Items.Count;
        ipAfter:
          if Assigned(RelItem) then
            Idx := RelItem.MenuIndex + 1
          else
            Idx := AMenu.Items.Count;
        ipBefore:
          if Assigned(RelItem) then
            Idx := RelItem.MenuIndex
          else
            Idx := 0;
      end;

      AMenu.Items.Insert(Idx, MenuItem);
    end;

    // һ TagԱ־û Name Զ˵
    MenuItem.Tag := csUserMenuItemTag;
    MenuItem.Caption := Item.Caption;
    MenuItem.Hint := Item.Hint;
    MenuItem.Enabled := msEnabled in Item.Status;
    MenuItem.Visible := msVisible in Item.Status;
    MenuItem.Checked := msChecked in Item.Status;
    MenuItem.OnClick := Item.Execute;
    MenuItem.Action := Item.Action;

    Item.MenuItemCreated(MenuItem);
  end
end;

procedure TCnMenuHook.DoRemoveMenuItem(AMenu: TPopupMenu;
  const AName: string);
var
  Item: TMenuItem;
begin
  Item := FindMenuItem(AMenu, AName);
  if Assigned(Item) then
    Item.Free;
end;

//------------------------------------------------------------------------------
// ˵ҽӴ
//------------------------------------------------------------------------------

function TCnMenuHook.GetMenuObj(Menu: TPopupMenu): TMenuObj;
var
  i: Integer;
begin
  for i := 0 to FMenuList.Count - 1 do
    if TMenuObj(FMenuList[i]).Menu = Menu then
    begin
      Result := TMenuObj(FMenuList[i]);
      Exit;
    end;
  Result := nil;
end;

procedure TCnMenuHook.HookMenu(AMenu: TPopupMenu);
begin
  if not IsHooked(AMenu) then
  begin
    FMenuList.Add(TMenuObj.Create(AMenu, OnMenuPopup));
    AMenu.FreeNotification(Self);
  end;
end;

procedure TCnMenuHook.UnHookMenu(AMenu: TPopupMenu);
var
  Obj: TMenuObj;
begin
  Obj := GetMenuObj(AMenu);
  if Assigned(Obj) then
  begin
{$IFDEF VER120} //for D4 only
    Obj.Menu.FreeNotification(Self);
{$ELSE}
    Obj.Menu.RemoveFreeNotification(Self);
{$ENDIF}
    FMenuList.Remove(Obj);
  end;
end;

function TCnMenuHook.IsHooked(AMenu: TPopupMenu): Boolean;
begin
  Result := Assigned(GetMenuObj(AMenu)); 
end;

procedure TCnMenuHook.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if (Operation = opRemove) and (AComponent is TPopupMenu) then
    UnHookMenu(AComponent as TPopupMenu)
end;

//------------------------------------------------------------------------------
// ˵ҽ
//------------------------------------------------------------------------------

function TCnMenuHook.AddUserMenuItem(
  Item: TCnAbstractUserMenuItem): Integer;
begin
  Result := FHookItemList.IndexOf(Item);
  if Result < 0 then
    Result := FHookItemList.Add(Item);
end;

procedure TCnMenuHook.RemoveUserMenuItem(Item: TCnAbstractUserMenuItem);
begin
  FHookItemList.Remove(Item);
end;

function TCnMenuHook.IndexOfUserMenuItem(
  const AName: string): Integer;
var
  i: Integer;
begin
  for i := 0 to UserMenuItemCount - 1 do
    if SameText(UserMenuItems[i].Name, AName) then
    begin
      Result := i;
      Exit;
    end;
  Result := -1;
end;

function TCnMenuHook.GetUserMenuItemCount: Integer;
begin
  Result := FHookItemList.Count;
end;

function TCnMenuHook.GetUserMenuItem(
  Index: Integer): TCnAbstractUserMenuItem;
begin
  Result := FHookItemList[Index];
end;

procedure TCnMenuHook.OnMenuPopup(Sender: TObject);
var
  Menu: TPopupMenu;
  MenuObj: TMenuObj;
  i: Integer;
begin
  Menu := Sender as TPopupMenu;

  // ȰǰעĲ˵
  for i := 0 to UserMenuItemCount - 1 do
    DoRemoveMenuItem(Menu, UserMenuItems[i].Name);
    
  //  Tag ȥûֵĲ˵
  for i := Menu.Items.Count - 1 downto 0 do
    if Menu.Items[i].Tag = csUserMenuItemTag then
      Menu.Items[i].Free;

  if Assigned(FOnRemoveMenuItem) then
    FOnRemoveMenuItem(Self, Menu);

  // ԭ¼
  MenuObj := GetMenuObj(Menu);
  if Assigned(MenuObj) then
    MenuObj.OldOnPopup(Sender);

  if Active then
  begin
    // ¸Զ˵
    for i := 0 to UserMenuItemCount - 1 do
      if UserMenuItems[i].Active then
        DoAddMenuItem(Menu, UserMenuItems[i]);

    if Assigned(FOnAddMenuItem) then
      FOnAddMenuItem(Self, Menu);
  end;
end;

procedure TCnMenuHook.SetActive(const Value: Boolean);
begin
  FActive := Value;
end;

end.

